
function love.load()
	
	width, height = 480, 320 -- units, not pixels
	unit = 20
	scale = 2
	
	love.window.setMode( width*2, height*2, {resizable=true} )

	map = {}
	for i = 0, (width-unit)/unit do
		map[i] = {}
		for j = 0, (height-unit)/unit do
			map[i][j] = 0
		end
	end
	
--	love.mouse.setGrabbed(true)
	mouse_line = {points = {}, pressed = false, last = {x=0, y=0}}
	lines = {}

end

 
function love.update(dt)
	
end

function draw_mouse_line ()
	local line = {}
	for i, point in ipairs (mouse_line.points) do
		table.insert (line, point.x/scale)
		table.insert (line, point.y/scale)
	end
	if #line >4 then
		love.graphics.line(line)
	end
--	table.insert (lines, line)
end


function love.draw()
	
	love.graphics.setDefaultFilter( 'nearest', 'nearest' )
	love.graphics.scale(scale)
	
	love.graphics.setLineStyle( "rough" )
	
	

	love.graphics.circle('line', love.mouse.getX( )/scale, love.mouse.getY( )/scale, 0.5*unit/scale)
	
	
--	for i, js in pairs (map) do
--		for j, value in pairs (js) do
--			love.graphics.rectangle('line', i*unit, j*unit, unit, unit)
--		end
--	end
	
	for i, line in pairs (lines) do
		love.graphics.line(line)
	end
	
	draw_mouse_line ()
	
	
	love.graphics.print (tostring(mouse_line.pressed))
	love.graphics.print (tostring(#mouse_line.points), 0, 15)
	love.graphics.print (tostring(#lines), 0, 30)
end


function love.mousepressed(x, y, button, istouch)
	if button == 1 then
		mouse_line.pressed = true
		mouse_line.last = {x=x, y=y}
		mouse_line.points = {}
	end
end

function love.mousemoved( x, y, dx, dy, istouch )
	
	if mouse_line.pressed then
		if ((x-mouse_line.last.x)^2+(y-mouse_line.last.y)^2) >= (unit/scale)^2 then
			local point = mouse_line.last
			mouse_line.last = {x=x, y=y}
			table.insert (mouse_line.points, point)
		end
	end
end

function love.mousereleased(x, y, button)
	if button == 1 then
		mouse_line.pressed = false
		local line = {}
		for i, point in ipairs (mouse_line.points) do
			table.insert (line, point.x/scale)
			table.insert (line, point.y/scale)
		end
		table.insert (lines, line)
	end
end

function love.keypressed(key, scancode, isrepeat)
	if key == "escape" then
		love.event.quit()
	elseif key == "kp+" then
		scale = scale*2^(1/2)
	elseif key == "kp-" then
		scale = scale/2^(1/2)
	end
end